<template>
  <form class="newsletter-form">
    <div class="form-inner">
      <div class="form-group" :class="{ 'form-group--error': $v.email.$error }">
        <div v-if="!$v.email.required" class="error-msg">
          {{ $tr('field_required') }}
        </div>
        <div v-if="!$v.email.email" class="error-msg">
          {{ $tr('field_required_email') }}
        </div>
        <UiCoreVInput
          v-model="$v.email.$model"
          :class="{ error: $v.email.$error }"
          :placeholder="$tr('form_placeholder_email')"
          @blur="validate"
          @input="validate"
        />
      </div>

      <UiCoreVButton
        class="btn-submit"
        :disabled="$v.$invalid || submitStatus === 'PENDING'"
        :loading="submitStatus === 'PENDING'"
        @click.prevent="submit"
      >
        {{ $tr('form_label_submit') }}
      </UiCoreVButton>
    </div>
    <div class="form__response">
      <p class="typo__p" :class="{ show: submitStatus === 'OK' }">
        {{ $tr('form_message_success') }}
      </p>
      <p class="typo__p" :class="{ show: submitStatus === 'PENDING' }">
        {{ $tr('form_message_pending') }}
      </p>
      <p class="typo__p" :class="{ show: submitStatus === 'SEND_ERROR' }">
        {{ $tr('form_message_error') }}
      </p>
      <p class="typo__p" :class="{ show: submitStatus === 'DUPLICATE_ERROR' }">
        {{ $tr('form_message_duplicate') }}
      </p>
    </div>
  </form>
</template>

<script>
import { required, email } from 'vuelidate/lib/validators'

export default {
  props: {
    legalCheckbox: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      email: null,
      name: null,
      firstname: null,
      acceptLegals: this.legalCheckbox ? null : true,
      submitStatus: '',
    }
  },
  validations: {
    email: {
      required,
      email,
    },

    acceptLegals: {
      required,
    },
  },
  computed: {
    checkBoxIcon() {
      return this.acceptLegals ? 'check_box' : 'check_box_outline_blank'
    },
    confirmationMessage() {
      return this.$i18n.t('form_message_success')
    },
  },
  mounted() {
    this.validate()
  },
  methods: {
    validate() {
      this.submitStatus = this.$v.$invalid ? 'ERROR' : 'VALIDATED'
      if (this.isUntouched) this.submitStatus = 'ERROR'
    },

    selectRegion(value) {
      this.region = value
    },

    submit() {
      this.$v.$touch()

      if (this.$v.$invalid) {
        this.submitStatus = 'ERROR'
      } else {
        this.submitStatus = 'PENDING'
        const axios = require('axios')
        axios
          .post(
            '/.netlify/functions/subscribe',
            {
              email: this.email,
            },
            { baseUrl: '/' }
          )
          .then((response) => {
            if (response.data.id) {
              this.submitStatus = 'OK'
            }
            if (response.data.code === 'duplicate_parameter') {
              this.submitStatus = 'DUPLICATE_ERROR'
            }
          })
          .catch((error) => {
            console.log(error)
            this.submitStatus = 'SEND_ERROR'
          })
      }
    },
    reset() {
      this.firstname = null
      this.name = null
      this.email = null
      this.submitStatus = null
    },
  },
}
</script>

<style lang="scss" scoped>
.newsletter-form {
  @apply w-full;

  // textarea
  --v-textarea-min-height: none;
  --v-textarea-max-height: 200px;
  --v-textarea-height: 200px;
  --textarea-background-color: white;
  --foreground-subdued: theme('colors.black');

  // input
  --v-input-color: theme('colors.black');
  --input-padding: 5px 20px 5px 20px;
  --input-height: 35px;
  --v-button-height: 35px;

  @screen xl {
    --input-height: 45px;
    --v-button-height: 45px;
  }
  --input-background-color: #fff;
  --v-input-placeholder-color: theme('colors.black');
  --primary: rgba(218, 218, 218, 0.8);

  --border-width: 0px;
  --border-radius: calc(var(--v-button-height) /2);
  --border-normal: theme('colors.black');
  --border-normal-alt: theme('colors.grey-darker');

  .form-inner {
    @apply w-full text-black gap-2 flex flex-row -ml-2;
  }

  .form-group {

    @apply w-full relative;
    border-radius: calc(var(--v-button-height) / 2);
    transition: all 600ms;

    @screen md {
      @apply mt-0;
    }
    .v-input{
        font-size: 16px;
    }

    .error-msg {
      @apply absolute right-0 top-0 mt-2 mr-4;

    }
  }


.form__response{
    @apply relative w-full h-10;
  .typo__p {
    @apply w-full flex-wrap text-left text-black absolute top-2 ;

    transition: opacity 200ms;
    opacity:0;
    &.show{
        opacity:1;
    }
  }
}

.btn-submit {
  --border-width: 3px;
  --border-radius: calc(var(--v-button-height) / 2);
  --border-normal: theme('colors.white');
  --border-normal-alt: theme('colors.white');
  --border-normal: theme('colors.white');
  --border-normal-alt: theme('colors.white');
  --v-button-color: theme('colors.grey-darker');
  --v-button-color-hover: theme('colors.black');
  --v-button-color-disabled: rgb(221, 219, 219);
  --v-button-background-color:  theme('colors.white');
  --v-button-background-color-hover: theme('colors.white');
  --v-button-background-color-disabled: theme('colors.white');

  --v-button-height: 40px;
  --v-button-width: 40px;
  --v-button-min-width: 75px;

   margin-left:-65px;

   --v-button-font-size: 30px;

   @screen lg {
        --v-button-height: 40px;
      }

  }
}
.form-group.form-group--error {
  --border-normal:rgba(255, 47, 0, 0.365)
  --border-normal-alt:rgba(255, 47, 0, 0.365)
}
</style>
